<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'rulecode',
    label: '规则编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'ruledesc',
    label: '规则描述',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'ruletype',
    label: '规则类型',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'rulesql',
    label: '规则sql',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'ruledomain',
    label: '是否有阈值',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'status',
    label: '状态是否可用',
    component: 'Input',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

